Index: c/src/lib/libbsp/i386/go32/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/i386/go32/startup/bspstart.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/i386/go32/startup/bspstart.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -21,9 +21,16 @@
  */
 
-#include <rtems.h>
 #include <bsp.h>
+#include <rtems/libio.h>
+ 
 #include <libcsupport.h>
-
+#include <z8036.h>
+ 
+#include <string.h>
+#include <fcntl.h>
+ 
+#ifdef STACK_CHECKER_ON
 #include <stackchk.h>
+#endif
 
 /*
@@ -36,4 +43,6 @@
 
 rtems_cpu_table Cpu_table;
+
+char *rtems_progname;
 
 /*      Initialize whatever libc we are using
@@ -58,4 +67,12 @@
 
     /*
+     *  Init the RTEMS libio facility to provide UNIX-like system
+     *  calls for use by newlib (ie: provide __open, __close, etc)
+     *  Uses malloc() to get area for the iops, so must be after malloc init
+     */
+
+    rtems_libio_init();
+
+    /*
      * Set up for the libc handling.
      */
@@ -75,59 +92,115 @@
 
 }
-
-void bsp_start()
+ 
+/*
+ * After drivers are setup, register some "filenames"
+ * and open stdin, stdout, stderr files
+ *
+ * Newlib will automatically associate the files with these
+ * (it hardcodes the numbers)
+ */
+ 
+void
+bsp_postdriver_hook(void)
 {
-    extern void * sbrk( int );
-
-    Cpu_table.pretasking_hook		= NULL;
-    Cpu_table.predriver_hook = bsp_libc_init;  /* RTEMS resources available */
-    Cpu_table.postdriver_hook = NULL;   /* Call our main() for constructors */
-    Cpu_table.idle_task	= NULL;  /* do not override system IDLE task */
-    Cpu_table.do_zero_of_workspace	= TRUE;
-    Cpu_table.interrupt_table_segment	= 0;/* get_ds(); */
-    Cpu_table.interrupt_table_offset	= (void *)0;
-    Cpu_table.interrupt_stack_size	= 4096;
-    Cpu_table.extra_system_initialization_stack = 0;
-
-    /*
-     *  Copy the table
-     */
-    BSP_Configuration = Configuration;
-
-    BSP_Configuration.work_space_start = sbrk( Configuration.work_space_size );
-    if ( BSP_Configuration.work_space_start == 0 )  {
-	/* Big trouble */
-	int	write( int, void *, int );
-	void	_exit( int );
-	char	msg[] = "bsp_start() couldn't sbrk() RTEMS work space\n";
-	write( 2, msg, sizeof msg - 1 );
-	_exit( 1 );
-    }
-
-    /*
-     * Add 1 region for Malloc in libc_low
-     */
-
-    BSP_Configuration.maximum_regions++;
-
-    /*
-     * Add 1 extension for newlib libc
-     */
+  int stdin_fd, stdout_fd, stderr_fd;
+ 
+  if ((stdin_fd = __open("/dev/console", O_RDONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD0');
+ 
+  if ((stdout_fd = __open("/dev/console", O_WRONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD1');
+ 
+  if ((stderr_fd = __open("/dev/console", O_WRONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD2');
+ 
+  if ((stdin_fd != 0) || (stdout_fd != 1) || (stderr_fd != 2))
+    rtems_fatal_error_occurred('STIO');
+}
+
+/* This is the original command line passed from DOS */
+char **	Go32_Argv;
+
+int main(
+  int argc,
+  char **argv,
+  char **environp
+)
+{
+  extern void * sbrk( int );
+  extern volatile void _exit( int );
+
+  /* Set up arguments that we can access later */
+  Go32_Argv = argv;
+
+  if ((argc > 0) && argv && argv[0])
+    rtems_progname = argv[0];
+  else
+    rtems_progname = "RTEMS";
+
+  Cpu_table.pretasking_hook	= NULL;
+  Cpu_table.predriver_hook = bsp_libc_init;  /* RTEMS resources available */
+  Cpu_table.postdriver_hook = bsp_postdriver_hook;
+  Cpu_table.idle_task = NULL;  /* do not override system IDLE task */
+  Cpu_table.do_zero_of_workspace = TRUE;
+  Cpu_table.interrupt_table_segment = 0;/* get_ds(); */
+  Cpu_table.interrupt_table_offset = (void *)0;
+  Cpu_table.interrupt_stack_size = 4096;
+  Cpu_table.extra_system_initialization_stack = 0;
+
+  /*
+   *  Copy the table
+   */
+  BSP_Configuration = Configuration;
+
+  BSP_Configuration.work_space_start = sbrk( Configuration.work_space_size );
+  if ( BSP_Configuration.work_space_start == 0 )  {
+    /* Big trouble */
+    int write( int, void *, int );
+    char msg[] = "bsp_start() couldn't sbrk() RTEMS work space\n";
+    write( 2, msg, sizeof msg - 1 );
+    _exit( 1 );
+  }
+
+  /*
+   * Add 1 region for Malloc in libc_low
+   */
+
+  BSP_Configuration.maximum_regions++;
+
+  /*
+   * Add 1 extension for newlib libc
+   */
 
 #ifdef RTEMS_NEWLIB
-    BSP_Configuration.maximum_extensions++;
-#endif
-
-    /*
-     * Add another extension if using the stack checker
-     */
+  BSP_Configuration.maximum_extensions++;
+#endif
+
+  /*
+   * Add another extension if using the stack checker
+   */
 
 #ifdef STACK_CHECKER_ON
-    BSP_Configuration.maximum_extensions++;
-#endif
-
-    rtems_initialize_executive( &BSP_Configuration, &Cpu_table );
-    /* does not return */
-
-    /* no cleanup necessary for GO32 */
+  BSP_Configuration.maximum_extensions++;
+#endif
+
+  /*
+   * Tell libio how many fd's we want and allow it to tweak config
+   */
+
+  rtems_libio_config(&BSP_Configuration, BSP_LIBIO_MAX_FDS);
+
+  rtems_initialize_executive( &BSP_Configuration, &Cpu_table );
+  /* does not return */
+
+  /* We only return here if the executive has finished.  This happens	*/
+  /* when the task has called exit().					*/
+  /* At this point we call _exit() which resides in djgcc.		*/
+    
+  for (;;)
+	  _exit( 0 );
+
+  /* no cleanup necessary for GO32 */
+
+  return 0;
 }
Index: c/src/lib/libbsp/i960/cvme961/clock/ckinit.c
===================================================================
--- c/src/lib/libbsp/i960/cvme961/clock/ckinit.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/i960/cvme961/clock/ckinit.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -21,7 +21,8 @@
 #include <stdlib.h>
 
-#include <rtems.h>
 #include <bsp.h>
-#include <clockdrv.h>
+#include <rtems/libio.h>
+
+#define CLOCK_VECTOR 5
 
 rtems_unsigned32 Clock_isrs;              /* ISRs until next tick */
@@ -30,21 +31,16 @@
                                           /* ticks since initialization */
 
-rtems_device_driver Clock_initialize(
-  rtems_device_major_number major,
-  rtems_device_minor_number minor,
-  void *pargp,
-  rtems_id id,
-  rtems_unsigned32 *rval )
-{
-  Install_clock( Clock_isr );
-  atexit( Clock_exit );
-}
+void Clock_exit( void );
+ 
+/*
+ * These are set by clock driver during its init
+ */
+ 
+rtems_device_major_number rtems_clock_major = ~0;
+rtems_device_minor_number rtems_clock_minor;
 
-void ReInstall_clock(
-  rtems_isr_entry clock_isr
-)
-{
-   (void) set_vector( clock_isr, 5, 1 );
-}
+
+/* this is later in the file to avoid it being inlined */
+rtems_isr Clock_isr( rtems_vector_number vector );
 
 void Install_clock(
@@ -58,9 +54,16 @@
 
   if ( BSP_Configuration.ticks_per_timeslice ) {
-    Old_ticker = set_vector( clock_isr, 5, 1 );
+    Old_ticker = set_vector( clock_isr, CLOCK_VECTOR, 1 );
     victimer = (volatile unsigned char *) 0xa00000c3;
     *victimer = 0x12;
     *victimer = 0x92;      /* 1000 HZ */
   }
+}
+
+void ReInstall_clock(
+  rtems_isr_entry clock_isr
+)
+{
+   (void) set_vector( clock_isr, CLOCK_VECTOR, 1 );
 }
 
@@ -76,2 +79,67 @@
   }
 }
+
+rtems_device_driver Clock_initialize(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+)
+{
+  Install_clock( Clock_isr );
+ 
+  atexit( Clock_exit );
+
+  /*
+   * make major/minor avail to others such as shared memory driver
+   */
+ 
+  rtems_clock_major = major;
+  rtems_clock_minor = minor;
+ 
+  return RTEMS_SUCCESSFUL;
+}
+ 
+rtems_device_driver Clock_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+)
+{
+    rtems_libio_ioctl_args_t *args = pargp;
+ 
+    if (args == 0)
+        goto done;
+ 
+    /*
+     * This is hokey, but until we get a defined interface
+     * to do this, it will just be this simple...
+     */
+ 
+    if (args->command == rtems_build_name('I', 'S', 'R', ' '))
+    {
+        Clock_isr(CLOCK_VECTOR);
+    }
+    else if (args->command == rtems_build_name('N', 'E', 'W', ' '))
+    {
+        ReInstall_clock(args->buffer);
+    }
+ 
+done:
+    return RTEMS_SUCCESSFUL;
+}
+
+rtems_isr Clock_isr(
+  rtems_vector_number vector
+)
+{
+  /* enable_tracing(); */
+  Clock_driver_ticks += 1;
+  if ( Clock_isrs == 1 ) {
+    rtems_clock_tick();
+    Clock_isrs = BSP_Configuration.microseconds_per_tick / 1000;
+  }
+  else
+    Clock_isrs -= 1;
+  i960_clear_intr( 5 );
+}
+
Index: c/src/lib/libbsp/i960/cvme961/console/console.c
===================================================================
--- c/src/lib/libbsp/i960/cvme961/console/console.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/i960/cvme961/console/console.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -1,4 +1,4 @@
 /*
- *  This file contains the MVME136 console IO package.
+ *  This file contains the CVME961 console IO package.
  *
  *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
@@ -15,7 +15,6 @@
 #define C961_INIT
 
-#include <rtems.h>
-#include "console.h"
-#include "bsp.h"
+#include <bsp.h>
+#include <rtems/libio.h>
 
 /*  console_initialize
@@ -33,10 +32,19 @@
   rtems_device_major_number  major,
   rtems_device_minor_number  minor,
-  void                      *arg,
-  rtems_id                   self,
-  rtems_unsigned32          *status
-)
-{
-  *status = RTEMS_SUCCESSFUL;
+  void                      *arg
+)
+{
+ rtems_status_code status;
+ 
+  status = rtems_io_register_name(
+    "/dev/console",
+    major,
+    (rtems_device_minor_number) 0
+  );
+ 
+  if (status != RTEMS_SUCCESSFUL)
+    rtems_fatal_error_occurred(status);
+ 
+  return RTEMS_SUCCESSFUL;
 }
 
@@ -101,47 +109,102 @@
 
 /*
- * __read  -- read bytes from the serial port. Ignore fd, since
- *            we only have stdin.
- */
-
-int __read(
-  int fd,
-  char *buf,
-  int nbytes
-)
-{
-  int i = 0;
-
-  for (i = 0; i < nbytes; i++) {
-    *(buf + i) = inbyte();
-    if ((*(buf + i) == '\n') || (*(buf + i) == '\r')) {
-      (*(buf + i++)) = '\n';
-      (*(buf + i)) = 0;
+ *  Open entry point
+ */
+ 
+rtems_device_driver console_open(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+ 
+/*
+ *  Close entry point
+ */
+ 
+rtems_device_driver console_close(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+ 
+/*
+ * read bytes from the serial port. We only have stdin.
+ */
+ 
+rtems_device_driver console_read(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  rtems_libio_rw_args_t *rw_args;
+  char *buffer;
+  int maximum;
+  int count = 0;
+ 
+  rw_args = (rtems_libio_rw_args_t *) arg;
+ 
+  buffer = rw_args->buffer;
+  maximum = rw_args->count;
+ 
+  for (count = 0; count < maximum; count++) {
+    buffer[ count ] = inbyte();
+    if (buffer[ count ] == '\n' || buffer[ count ] == '\r') {
+      buffer[ count++ ]  = '\n';
+      buffer[ count ]  = 0;
       break;
     }
   }
-  return (i);
-}
-
-/*
- * __write -- write bytes to the serial port. Ignore fd, since
- *            stdout and stderr are the same. Since we have no filesystem,
- *            open will only return an error.
- */
-
-int __write(
-  int fd,
-  char *buf,
-  int nbytes
-)
-{
-  int i;
-
-  for (i = 0; i < nbytes; i++) {
-    if (*(buf + i) == '\n') {
-      outbyte ('\r');
+ 
+  rw_args->bytes_moved = count;
+  return (count >= 0) ? RTEMS_SUCCESSFUL : RTEMS_UNSATISFIED;
+}
+ 
+/*
+ * write bytes to the serial port. Stdout and stderr are the same.
+ */
+ 
+rtems_device_driver console_write(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  int count;
+  int maximum;
+  rtems_libio_rw_args_t *rw_args;
+  char *buffer;
+ 
+  rw_args = (rtems_libio_rw_args_t *) arg;
+ 
+  buffer = rw_args->buffer;
+  maximum = rw_args->count;
+ 
+  for (count = 0; count < maximum; count++) {
+    if ( buffer[ count ] == '\n') {
+      outbyte('\r');
     }
-    outbyte (*(buf + i));
+    outbyte( buffer[ count ] );
   }
-  return (nbytes);
-}
+  return maximum;
+}
+ 
+/*
+ *  IO Control entry point
+ */
+ 
+rtems_device_driver console_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+
Index: c/src/lib/libbsp/i960/cvme961/include/bsp.h
===================================================================
--- c/src/lib/libbsp/i960/cvme961/include/bsp.h	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/i960/cvme961/include/bsp.h	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -25,4 +25,6 @@
 #include <rtems.h>
 #include <iosupp.h>
+#include <console.h>
+#include <clockdrv.h>
 
 /*
@@ -116,4 +118,22 @@
 BSP_EXTERN i960ca_control_table *Ctl_tbl;
 
+/*
+ *  Device Driver Table Entries
+ */
+
+/*
+ * NOTE: Use the standard Console driver entry
+ */
+ 
+/*
+ * NOTE: Use the standard Clock driver entry
+ */
+
+/*
+ * How many libio files we want
+ */
+
+#define BSP_LIBIO_MAX_FDS       20
+
 /* functions */
 
Index: c/src/lib/libbsp/i960/cvme961/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/i960/cvme961/startup/bspstart.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/i960/cvme961/startup/bspstart.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -21,10 +21,15 @@
  */
 
-#include <rtems.h>
 #include <bsp.h>
-#include "libcsupport.h"
-
-
-#include "stackchk.h"
+#include <rtems/libio.h>
+ 
+#include <libcsupport.h>
+ 
+#include <string.h>
+#include <fcntl.h>
+ 
+#ifdef STACK_CHECKER_ON
+#include <stackchk.h>
+#endif
 
 /*
@@ -38,4 +43,6 @@
 
 rtems_cpu_table Cpu_table;
+
+char *rtems_progname;
 
 /*      Initialize whatever libc we are using
@@ -53,4 +60,12 @@
 
     RTEMS_Malloc_Initialize((void *) heap_start, 64 * 1024, 0);
+
+    /*
+     *  Init the RTEMS libio facility to provide UNIX-like system
+     *  calls for use by newlib (ie: provide __open, __close, etc)
+     *  Uses malloc() to get area for the iops, so must be after malloc init
+     */
+
+    rtems_libio_init();
 
     /*
@@ -71,5 +86,31 @@
 }
 
-int bsp_start(
+/*
+ * After drivers are setup, register some "filenames"
+ * and open stdin, stdout, stderr files
+ *
+ * Newlib will automatically associate the files with these
+ * (it hardcodes the numbers)
+ */
+ 
+void
+bsp_postdriver_hook(void)
+{
+  int stdin_fd, stdout_fd, stderr_fd;
+ 
+  if ((stdin_fd = __open("/dev/console", O_RDONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD0');
+ 
+  if ((stdout_fd = __open("/dev/console", O_WRONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD1');
+ 
+  if ((stderr_fd = __open("/dev/console", O_WRONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD2');
+ 
+  if ((stdin_fd != 0) || (stdout_fd != 1) || (stderr_fd != 2))
+    rtems_fatal_error_occurred('STIO');
+}
+
+int main(
   int argc,
   char **argv,
@@ -77,4 +118,9 @@
 )
 {
+  if ((argc > 0) && argv && argv[0])
+    rtems_progname = argv[0];
+  else
+    rtems_progname = "RTEMS";
+
   /* set node number in SQSIO4 CTL REG */
 
@@ -111,5 +157,5 @@
   Cpu_table.predriver_hook = bsp_libc_init;  /* RTEMS resources available */
 
-  Cpu_table.postdriver_hook = NULL;   /* Call our main() for constructors */
+  Cpu_table.postdriver_hook = bsp_postdriver_hook;
 
   Cpu_table.idle_task = NULL;  /* do not override system IDLE task */
@@ -151,4 +197,10 @@
 #endif
 
+  /*
+   * Tell libio how many fd's we want and allow it to tweak config
+   */
+
+  rtems_libio_config(&BSP_Configuration, BSP_LIBIO_MAX_FDS);
+
   BSP_Configuration.work_space_start = (void *)
      (RAM_END - BSP_Configuration.work_space_size);
Index: c/src/lib/libbsp/m68k/dmv152/clock/ckinit.c
===================================================================
--- c/src/lib/libbsp/m68k/dmv152/clock/ckinit.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/m68k/dmv152/clock/ckinit.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -20,8 +20,7 @@
 
 #include <stdlib.h>
-
-#include <rtems.h>
+ 
 #include <bsp.h>
-#include <clockdrv.h>
+#include <rtems/libio.h>
 
 rtems_unsigned32 Clock_isrs;        /* ISRs until next tick */
@@ -30,24 +29,35 @@
 rtems_isr_entry  Old_ticker;
 
-rtems_device_driver Clock_initialize(
-  rtems_device_major_number major,
-  rtems_device_minor_number minor,
-  void *pargp,
-  rtems_id tid,
-  rtems_unsigned32 *rval
+void Clock_exit( void );
+
+#define CLOCK_VECTOR  TIMER_VECTOR
+ 
+/*
+ * These are set by clock driver during its init
+ */
+ 
+rtems_device_major_number rtems_clock_major = ~0;
+rtems_device_minor_number rtems_clock_minor;
+
+/*
+ *  ISR Handler
+ */
+
+rtems_isr Clock_isr(
+  rtems_vector_number vector
 )
 {
-  Install_clock( Clock_isr );
-}
+  Clock_driver_ticks += 1;
 
-void ReInstall_clock(
-  rtems_isr_entry clock_isr
-)
-{
-  rtems_unsigned32 isrlevel = 0 ;
+  Z8x36_WRITE( TIMER, CT1_CMD_STATUS, 0xE2 );
+  Z8x36_WRITE( TIMER, CT1_CMD_STATUS, 0x22 );
+  Z8x36_WRITE( TIMER, CT1_CMD_STATUS, 0xC6 );
 
-  rtems_interrupt_disable( isrlevel );
-   (void) set_vector( clock_isr, TIMER_VECTOR, 1 );
-  rtems_interrupt_enable( isrlevel );
+  if ( Clock_isrs == 1 ) {
+    rtems_clock_tick();
+    Clock_isrs = BSP_Configuration.microseconds_per_tick / 1000;
+  }
+  else
+    Clock_isrs -= 1;
 }
 
@@ -62,5 +72,5 @@
 
   if ( BSP_Configuration.ticks_per_timeslice ) {
-    Old_ticker = (rtems_isr_entry) set_vector( clock_isr, TIMER_VECTOR, 1 );
+    Old_ticker = (rtems_isr_entry) set_vector( clock_isr, CLOCK_VECTOR, 1 );
 
     Z8x36_WRITE( TIMER, MASTER_CFG, 0xd4 );
@@ -70,5 +80,5 @@
     Z8x36_WRITE( TIMER, CT1_TIME_CONST_LSB, 0xCE );
     Z8x36_WRITE( TIMER, CT1_MODE_SPEC, 0x83 );
-    Z8x36_WRITE( TIMER, CNT_TMR_VECTOR, TIMER_VECTOR );
+    Z8x36_WRITE( TIMER, CNT_TMR_VECTOR, CLOCK_VECTOR );
     Z8x36_WRITE( TIMER, CT1_CMD_STATUS, 0x20 );
     Z8x36_READ ( TIMER, MASTER_INTR, data );
@@ -88,4 +98,15 @@
 }
 
+void ReInstall_clock(
+  rtems_isr_entry clock_isr
+)
+{
+  rtems_unsigned32 isrlevel = 0 ;
+
+  rtems_interrupt_disable( isrlevel );
+   (void) set_vector( clock_isr, CLOCK_VECTOR, 1 );
+  rtems_interrupt_enable( isrlevel );
+}
+
 void Clock_exit( void )
 {
@@ -100,2 +121,50 @@
   }
 }
+
+rtems_device_driver Clock_initialize(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+)
+{
+  Install_clock( Clock_isr );
+ 
+  /*
+   * make major/minor avail to others such as shared memory driver
+   */
+ 
+  rtems_clock_major = major;
+  rtems_clock_minor = minor;
+ 
+  return RTEMS_SUCCESSFUL;
+}
+ 
+rtems_device_driver Clock_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+)
+{
+    rtems_libio_ioctl_args_t *args = pargp;
+ 
+    if (args == 0)
+        goto done;
+ 
+    /*
+     * This is hokey, but until we get a defined interface
+     * to do this, it will just be this simple...
+     */
+ 
+    if (args->command == rtems_build_name('I', 'S', 'R', ' '))
+    {
+        Clock_isr(CLOCK_VECTOR);
+    }
+    else if (args->command == rtems_build_name('N', 'E', 'W', ' '))
+    {
+        ReInstall_clock(args->buffer);
+    }
+ 
+done:
+    return RTEMS_SUCCESSFUL;
+}
+
Index: c/src/lib/libbsp/m68k/dmv152/console/console.c
===================================================================
--- c/src/lib/libbsp/m68k/dmv152/console/console.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/m68k/dmv152/console/console.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -15,8 +15,7 @@
 #define D152_INIT
 
-#include <rtems.h>
-#include "console.h"
-#include "bsp.h"
-
+#include <bsp.h>
+#include <rtems/libio.h>
+ 
 /*  console_initialize
  *
@@ -29,16 +28,24 @@
  *  Return values:
  */
-
+ 
 rtems_device_driver console_initialize(
   rtems_device_major_number  major,
   rtems_device_minor_number  minor,
-  void                      *arg,
-  rtems_id                   self,
-  rtems_unsigned32          *status
-)
-{
-  *status = RTEMS_SUCCESSFUL;
-}
-
+  void                      *arg
+)
+{
+  rtems_status_code status;
+ 
+  status = rtems_io_register_name(
+    "/dev/console",
+    major,
+    (rtems_device_minor_number) 0
+  );
+ 
+  if (status != RTEMS_SUCCESSFUL)
+    rtems_fatal_error_occurred(status);
+ 
+  return RTEMS_SUCCESSFUL;
+}
 
 /*  is_character_ready
@@ -140,47 +147,101 @@
 
 /*
- * __read  -- read bytes from the serial port. Ignore fd, since
- *            we only have stdin.
- */
-
-int __read(
-  int fd,
-  char *buf,
-  int nbytes
-)
-{
-  int i = 0;
-
-  for (i = 0; i < nbytes; i++) {
-    *(buf + i) = inbyte();
-    if ((*(buf + i) == '\n') || (*(buf + i) == '\r')) {
-      (*(buf + i++)) = '\n';
-      (*(buf + i)) = 0;
+ *  Open entry point
+ */
+
+rtems_device_driver console_open(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+ 
+/*
+ *  Close entry point
+ */
+
+rtems_device_driver console_close(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
+
+/*
+ * read bytes from the serial port. We only have stdin.
+ */
+
+rtems_device_driver console_read(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  rtems_libio_rw_args_t *rw_args;
+  char *buffer;
+  int maximum;
+  int count = 0;
+ 
+  rw_args = (rtems_libio_rw_args_t *) arg;
+
+  buffer = rw_args->buffer;
+  maximum = rw_args->count;
+
+  for (count = 0; count < maximum; count++) {
+    buffer[ count ] = inbyte();
+    if (buffer[ count ] == '\n' || buffer[ count ] == '\r') {
+      buffer[ count++ ]  = '\n';
+      buffer[ count ]  = 0;
       break;
     }
   }
-  return (i);
-}
-
-/*
- * __write -- write bytes to the serial port. Ignore fd, since
- *            stdout and stderr are the same. Since we have no filesystem,
- *            open will only return an error.
- */
-
-int __write(
-  int fd,
-  char *buf,
-  int nbytes
-)
-{
-  int i;
-
-  for (i = 0; i < nbytes; i++) {
-    if (*(buf + i) == '\n') {
-      outbyte ('\r');
+
+  rw_args->bytes_moved = count;
+  return (count >= 0) ? RTEMS_SUCCESSFUL : RTEMS_UNSATISFIED;
+}
+
+/*
+ * write bytes to the serial port. Stdout and stderr are the same. 
+ */
+
+rtems_device_driver console_write(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  int count;
+  int maximum;
+  rtems_libio_rw_args_t *rw_args;
+  char *buffer;
+
+  rw_args = (rtems_libio_rw_args_t *) arg;
+
+  buffer = rw_args->buffer;
+  maximum = rw_args->count;
+
+  for (count = 0; count < maximum; count++) {
+    if ( buffer[ count ] == '\n') {
+      outbyte('\r');
     }
-    outbyte (*(buf + i));
-  }
-  return (nbytes);
-}
+    outbyte( buffer[ count ] );
+  }
+  return maximum;
+}
+
+/*
+ *  IO Control entry point
+ */
+
+rtems_device_driver console_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void                    * arg
+)
+{
+  return RTEMS_SUCCESSFUL;
+}
Index: c/src/lib/libbsp/m68k/dmv152/include/bsp.h
===================================================================
--- c/src/lib/libbsp/m68k/dmv152/include/bsp.h	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/m68k/dmv152/include/bsp.h	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -22,5 +22,8 @@
 
 #include <rtems.h>
+#include <console.h>
+#include <clockdrv.h>
 #include <iosupp.h>
+#include <vmeintr.h>
 #include <z8530.h>
 #include <z8536.h>
@@ -152,4 +155,22 @@
 extern m68k_isr_entry M68Kvec[];   /* vector table address */
 
+/*
+ *  Device Driver Table Entries
+ */
+
+/*
+ * NOTE: Use the standard Console driver entry
+ */
+ 
+/*
+ * NOTE: Use the standard Clock driver entry
+ */
+
+/*
+ * How many libio files we want
+ */
+
+#define BSP_LIBIO_MAX_FDS       20
+
 /* functions */
 
Index: c/src/lib/libbsp/m68k/dmv152/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/m68k/dmv152/startup/bspstart.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/m68k/dmv152/startup/bspstart.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -22,9 +22,15 @@
  */
 
-#include <rtems.h>
 #include <bsp.h>
+#include <rtems/libio.h>
+ 
 #include <libcsupport.h>
-#include <vmeintr.h>
-
+ 
+#include <string.h>
+#include <fcntl.h>
+ 
+#ifdef STACK_CHECKER_ON
+#include <stackchk.h>
+#endif
 /*
  *  The original table from the application and our copy of it with
@@ -36,4 +42,6 @@
 
 rtems_cpu_table Cpu_table;
+
+char *rtems_progname;
 
 /*      Initialize whatever libc we are using
@@ -53,4 +61,12 @@
 
     /*
+     *  Init the RTEMS libio facility to provide UNIX-like system
+     *  calls for use by newlib (ie: provide __open, __close, etc)
+     *  Uses malloc() to get area for the iops, so must be after malloc init
+     */
+
+    rtems_libio_init();
+
+    /*
      * Set up for the libc handling.
      */
@@ -70,5 +86,31 @@
 }
 
-int bsp_start(
+/*
+ * After drivers are setup, register some "filenames"
+ * and open stdin, stdout, stderr files
+ *
+ * Newlib will automatically associate the files with these
+ * (it hardcodes the numbers)
+ */
+ 
+void
+bsp_postdriver_hook(void)
+{
+  int stdin_fd, stdout_fd, stderr_fd;
+ 
+  if ((stdin_fd = __open("/dev/console", O_RDONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD0');
+ 
+  if ((stdout_fd = __open("/dev/console", O_WRONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD1');
+ 
+  if ((stderr_fd = __open("/dev/console", O_WRONLY, 0)) == -1)
+    rtems_fatal_error_occurred('STD2');
+ 
+  if ((stdin_fd != 0) || (stdout_fd != 1) || (stderr_fd != 2))
+    rtems_fatal_error_occurred('STIO');
+}
+
+int main(
   int argc,
   char **argv,
@@ -80,4 +122,9 @@
   void           *vbr;
 
+  if ((argc > 0) && argv && argv[0])
+    rtems_progname = argv[0];
+  else
+    rtems_progname = "RTEMS";
+
   monitors_vector_table = (m68k_isr_entry *)0;   /* Monitor Vectors are at 0 */
   m68k_set_vbr( monitors_vector_table );
@@ -116,5 +163,5 @@
   Cpu_table.predriver_hook = bsp_libc_init;  /* RTEMS resources available */
 
-  Cpu_table.postdriver_hook = NULL;   /* Call our main() for constructors */
+  Cpu_table.postdriver_hook = bsp_postdriver_hook;
 
   Cpu_table.idle_task = NULL;  /* do not override system IDLE task */
@@ -159,4 +206,10 @@
     BSP_Configuration.maximum_extensions++;
 #endif
+
+  /*
+   * Tell libio how many fd's we want and allow it to tweak config
+   */
+
+  rtems_libio_config(&BSP_Configuration, BSP_LIBIO_MAX_FDS);
 
   rtems_initialize_executive( &BSP_Configuration, &Cpu_table );
Index: c/src/lib/libbsp/m68k/gen68302/clock/ckinit.c
===================================================================
--- c/src/lib/libbsp/m68k/gen68302/clock/ckinit.c	(revision 7f6a24abdd1793e394e4d5d49de1f4ca0e00297a)
+++ c/src/lib/libbsp/m68k/gen68302/clock/ckinit.c	(revision 3a4ae6c210bcc37754767966f1128ae23c77b6af)
@@ -21,9 +21,10 @@
 #include <stdlib.h>			/* for atexit() */
 
-#include <rtems.h>
 #include <bsp.h>
-#include <clockdrv.h>
+#include <rtems/libio.h>
+
 #include "m68302.h"
 
+#define CLOCK_VECTOR 137
 
 #define TMR1_VAL (  RBIT_TMR_RST	/* software reset the timer */\
@@ -50,16 +51,33 @@
 rtems_unsigned32 Clock_isrs;
 
+void Clock_exit( void );
+ 
+/*
+ * These are set by clock driver during its init
+ */
+ 
+rtems_device_major_number rtems_clock_major = ~0;
+rtems_device_minor_number rtems_clock_minor;
 
-rtems_device_driver Clock_initialize( 
-  rtems_device_major_number major,
-  rtems_device_minor_number minor,
-  void *pargp,
-  rtems_id tid,
-  rtems_unsigned32 *rval
+/*
+ *  ISR Handler
+ */
+
+rtems_isr Clock_isr(
+  rtems_vector_number vector
 )
 {
-  Install_clock( Clock_isr );
+  Clock_driver_ticks += 1;
+
+  m302.reg.isr  = RBIT_ISR_TIMER1;	/* clear in-service bit */
+  m302.reg.ter1 = (RBIT_TER_REF | RBIT_TER_CAP); /* clear timer intr request */
+
+  if ( Clock_isrs == 1 ) {
+    rtems_clock_tick();
+    Clock_isrs = BSP_Configuration.microseconds_per_tick / 1000;
+  }
+  else
+    Clock_isrs -= 1;
 }
-
 
 void Install_clock(
@@ -72,5 +90,5 @@
 
   if ( BSP_Configuration.ticks_per_timeslice ) {
-/*  set_vector( clock_isr, 137, 1 );*/
+/*  set_vector( clock_isr, CLOCK_VECTOR, 1 );*/
 
     m302.reg.trr1 = TRR1_VAL;		/* set timer reference register */
@@ -85,4 +103,14 @@
 }
 
+void ReInstall_clock(
+  rtems_isr_entry clock_isr
+)
+{
+  rtems_unsigned32 isrlevel;
+ 
+  rtems_interrupt_disable( isrlevel );
+   /* (void) set_vector( clock_isr, CLOCK_VECTOR, 1 ); */
+  rtems_interrupt_enable( isrlevel );
+}
 
 void Clock_exit( void )
@@ -93,2 +121,50 @@
   }
 }
+
+rtems_device_driver Clock_initialize(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+)
+{
+  Install_clock( Clock_isr );
+ 
+  /*
+   * make major/minor avail to others such as shared memory driver
+   */
+ 
+  rtems_clock_major = major;
+  rtems_clock_minor = minor;
+ 
+  return RTEMS_SUCCESSFUL;
+}
+ 
+rtems_device_driver Clock_control(
+  rtems_device_major_number major,
+  rtems_device_minor_number minor,
+  void *pargp
+)
+{
+    rtems_libio_ioctl_args_t *args = pargp;
+ 
+    if (args == 0)
+        goto done;
+ 
+    /*
+     * This is hokey, but until we get a defined interface
+     * to do this, it will just be this simple...
+     */
+ 
+    if (args->command == rtems_build_name('I', 'S', 'R', ' '))
+    {
+        Clock_isr( CLOCK_VECTOR);
+    }
+    else if (args->command == rtems_build_name('N', 'E', 'W', ' '))
+    {
+        ReInstall_clock(args->buffer);
+    }
+ 
+done:
+    return RTEMS_SUCCESSFUL;
+}
+
